/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 * VN.c -- assorted Von Neumann machine code:
 *  do_VN() -- called by doship()
 *  planet_doVN() -- called by doplanet()
 */
#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "doturn.h"
#include "power.h"
#include "buffers.h"

do_VN(ship,shipno)
shiptype *ship;
int shipno;
{
int r; 
planettype *p;
char buf[300];

  if (ship->on) {

    if (ship->whatorbits==LEVEL_PLAN)
    	p = planets[ship->storbits][ship->pnumorbits];

    if (ship->whatorbits==LEVEL_PLAN &&
	ship->is_docked && ship->whatdest==LEVEL_PLAN) {
		/* make sure the planet is updated */
	Stinfo[ship->storbits][ship->pnumorbits].inhab = 1;

		/* launch if no assignment */
	if (ship->object.number2 == 0) {
		if (ship->fuel >= Shipdata[OTYPE_VN][ABIL_FUELCAP]) {
			/* launch. */
		   ship->object.number2 = 0; /* no current assignment */
		   ship->xpos = Stars[ship->storbits]->xpos + planets[ship->storbits][ship->pnumorbits]->xpos + int_rand(-10,10);
		   ship->ypos = Stars[ship->storbits]->ypos + planets[ship->storbits][ship->pnumorbits]->ypos + int_rand(-10,10);
		   ship->is_docked = 0;
		   ship->whatdest = LEVEL_UNIV;
		} else {
		   /* instead of stealing, wait until we have enough fuel */
		 /*for (r=1; !f && r<=Num_races; r++)
		  if (p->info[r-1].fuel >= Shipdata[OTYPE_VN][ABIL_FUELCAP])
			f = r;
	          if (f) {
			 /* we found a player to steal fuel from */
			/*ship->fuel += Shipdata[OTYPE_VN][ABIL_FUELCAP];
			ship->mass += Shipdata[OTYPE_VN][ABIL_FUELCAP]*MASS_FUEL;
		  	p->info[f-1].fuel -= Shipdata[OTYPE_VN][ABIL_FUELCAP];
			sprintf(buf,"%d fuel stolen by %s #%d on planet /%s/%s!\n",
			   Shipdata[OTYPE_VN][ABIL_FUELCAP],
			   Shipnames[OTYPE_VN],
			   shipno, Stars[ship->storbits]->name,
			   Stars[ship->storbits]->pnames[ship->pnumorbits]);
			notify(f, buf);
		   }*/

	     }
	} else {
		/* VNs: I decided to take out this stuff, since from now
		 *  on they get pissed at people.  They will be much
		 *  more low-profile, taking resources from the player
		 *  only indirectly.  I'll keep this stuff in comments,
		 *  though, for posterity, I guess.
		 */

		/* we have an assignment.  Since we are landed, this means
		   we are engaged in building up resources/fuel. */
		/* steal resources from other players */
reg int i,f; int nums[MAXPLAYERS+1];
		  /* permute list of people to steal from */

/* I kind of like this stuff -Garrett */
		for (i=1; i<=Num_races; i++)
			nums[i] = i;
		for (i=1; i<=Num_races; i++) {
			f = int_rand(1,Num_races);
			swap(nums[i], nums[f]);
		}
		for (f=0,i=1; i<=Num_races; i++)
			if (p->info[nums[i]-1].resource)
				f = nums[i];
		if (f) {
		  	p->info[f-1].resource -= 
				MIN( p->info[f-1].resource, 
					Shipdata[OTYPE_VN][ABIL_COST]);
			ship->resource += Shipdata[OTYPE_VN][ABIL_COST];
			ship->mass += Shipdata[OTYPE_VN][ABIL_COST] * MASS_RESOURCE;
			sprintf(buf,"%d resources stolen by %s #%d\non planet ",
			     Shipdata[OTYPE_VN][ABIL_COST],
			     Shipnames[OTYPE_VN], shipno);
			notify(f, buf);
			sprintf(buf,"%s!\n", prin_ship_orbits(ship) );
			notify(f, buf);
		} else {
		 /*if no resources to steal, more will be produced in doplanet*/
		}
	}
  } else {
	/* we are not landed */
	if (ship->object.number2) {
		/* we've arrived from somewhere -- look for a place to land.  
		   this is done on planet turn since we need to scan the
		   sectormap for a landing spot */
	} else {
		/* we were just built & launched */
		reg int s,min=0,min2=0;
		  /* find closest unexplored star */
		for (s=1; s<Sdata.numstars; s++)
			if (s != ship->storbits &&
				Distsq(Stars[s]->xpos,Stars[s]->ypos,ship->xpos,ship->ypos) < 
				Distsq(Stars[min]->xpos,Stars[min]->ypos,ship->xpos,ship->ypos))
				   min2 = min,min = s;
			/* don't go there if we have a choice, 
			   and we have VN's there already */
		if (isset(Stars[min]->inhabited,1))
		  if (isset(Stars[min2]->inhabited,1))
			ship->deststar = int_rand(0,Sdata.numstars-1);
		  else
			ship->deststar = min2;	/* 2nd closest star */
		else
		      ship->deststar = min;
		if (Stars[ship->deststar]->numplanets) {
			ship->destpnum =
				int_rand(0,Stars[ship->deststar]->numplanets-1);
		 	ship->whatdest = LEVEL_PLAN;
			ship->object.number2 = 1;
		} else {
			/* no good; find someplace else. */
			ship->object.number2 = 0;
		}
		ship->speed = 1;	/* VN's are very fastidious */
		fprintf(stderr,"VN #%d headed for star %d, pl %d.\n",shipno,ship->deststar, ship->destpnum);
			/* we are assigned to go */
	}
  }
 
 }

}



/*
 *  planet_doVN() : run a VN on a planet.  called by doplanet().
 *    if we're landed on the planet, we check if we have enough resources.
 *	 if we have enough, and we have fuel, build another machine and
 *	 	launch ourselves, and find a place to go to.
 *       if we don't have enough, rove around some and find some.
 *    if we're orbiting a planet, find a place to land there.
 *
 */

planet_doVN(ship, shipno, planet)
shiptype *ship;
int shipno;
planettype *planet;
{
 reg int i;

     if (ship->on) {

      if (ship->is_docked && ship->whatdest==LEVEL_PLAN) {

	if (ship->object.number2) {
		/* we are currently trying to construct another
		   machine */
	  reg int x,y,a,dum,shipbuild;

	     /* spread VN's all over the planet for display */
	  /*for (i=1; i<253 && i<=ship->object.number; i++) {
	    a = round_rand(sqrt((double)ship->object.number));
	    x = mod(int_rand((int)(ship->xpos-a),(int)(ship->xpos+a)),(int)planet->xpos,dum);
	    y = mod(int_rand((int)(ship->ypos-a),(int)(ship->ypos+a)),(int)planet->ypos,dum);
	    Sectinfo[x][y].VN= 1;
	  }*/

	  shipbuild = (VN_brain.Total_mad > 900 && random()&01) ? OTYPE_BERS : OTYPE_VN;
	  if ((ship->type==OTYPE_VN) && (ship->resource >= Shipdata[shipbuild][ABIL_COST])) {
		 shiptype *s2; reg int n;

	   ship->resource -= Shipdata[shipbuild][ABIL_COST];
	   ship->mass -= Shipdata[shipbuild][ABIL_COST]*MASS_RESOURCE;

		  /* must change size of ships pointer */
	   ++Num_ships;
	   ships = (shiptype **)realloc(ships, (Num_ships+1)*sizeof(shiptype*)); 
	   ships[Num_ships] = Malloc(shiptype);
	   s2 = ships[Num_ships];
	   bzero((char *)s2,sizeof(shiptype));

	   s2->nextship = planet->ships;
	   planet->ships = Num_ships;

	   s2->whatorbits = LEVEL_PLAN;
	   s2->storbits = ship->storbits;
	   s2->pnumorbits = ship->pnumorbits;
	   s2->is_docked = 1;
	   s2->xpos = ((int)ship->xpos + int_rand(-2,2)) % planet->Maxx;
	   s2->xpos = abs(s2->xpos);
	   s2->ypos = ((int)ship->ypos + rposneg()) % planet->Maxy;
	   s2->ypos = abs(s2->ypos);
	   s2->whatdest = ship->whatdest;
	   s2->deststar = ship->deststar;
	   s2->destpnum = ship->destpnum;
	   s2->type = shipbuild;

	s2->armor = Shipdata[shipbuild][ABIL_ARMOR];
	s2->guns = Shipdata[shipbuild][ABIL_GUNS];
	s2->size = Shipdata[shipbuild][ABIL_TARGET];
	s2->max_crew = Shipdata[shipbuild][ABIL_MAXCREW];
	s2->max_resource = Shipdata[shipbuild][ABIL_CARGO];
	s2->max_fuel = Shipdata[shipbuild][ABIL_FUELCAP];
	s2->max_destruct = Shipdata[shipbuild][ABIL_DESTCAP];
	s2->max_speed = Shipdata[shipbuild][ABIL_SPEED];
	   s2->base_mass = getmass(s2);

	   s2->mass = s2->base_mass;
			/* is not dead */
	   s2->is_alive = 1;

	   if (shipbuild==OTYPE_BERS) {
		  fprintf(stderr,"VN #%d constructed Bers #%d.\n",shipno,Num_ships);
		  s2->owner = 1;
		  s2->on = 1;
			/* target = person killed the most VN's */
		  s2->object.number = VN_brain.Most_mad;
		  sprintf(s2->name,"%d",s2->object.number);
		  s2->speed = Shipdata[OTYPE_BERS][ABIL_SPEED];
		  s2->tech = ship->tech + 1.0;
		  s2->bombard = 1;
		  s2->protect.self = 1;
		  s2->protect.planet = 1;
	   } else {
		  fprintf(stderr,"VN #%d constructed VN #%d.\n",shipno,Num_ships);
		  s2->tech = ship->tech + 1.0;

	   	  n = int_rand(3,MIN(10,SHIP_NAMESIZE));	/* for name */
	   	  s2->name[n] = '\0';
	   	  while (n--)
			s2->name[n] = (random()&01) + '0';

		  s2->owner = (int_rand(0,1) ? ship->owner : 1);
			/* one of them */
		  s2->object.number = 1;
			/* is not building any VN's */
		  ship->object.number2 = 0;
			/* turn it on */
		  s2->on = 1;
			/* set speed */
		  s2->speed = 1;
		  s2->bombard = 0;
	   }

	} else {
		/* try and make some resources(VNs)/detruct(Bers) by ourselves.
		   more might be stolen in doship */
		sectortype *s; reg int oldres,xa,ya,dum,prod;
		s = &Sector(*planet,(int)ship->xpos, (int)ship->ypos);

		if ((oldres = s->resource) == 0) {
		   /* move to another sector */
		   xa = int_rand(-1,1);
		   ship->xpos = mod((int)ship->xpos+xa,planet->Maxx,dum);
		   ya = (ship->ypos==0.0) ? 1 : 
		      ( (ship->ypos==planet->Maxy-1) ? -1 : rposneg());
		   ship->ypos += ya;
		} else {
		   /* mine the sector */
			s->resource *= VN_RES_TAKE;
			prod = oldres - s->resource; /* poor way for a player to mine resources */
		if(ship->type==OTYPE_VN) {
			ship->resource += prod;
			ship->mass += prod * MASS_RESOURCE;
		} else {
			ship->destruct += prod; /* Berserkers need weapons */
			ship->mass += prod * MASS_DESTRUCT;
			}
		
			ship->fuel += prod;
			ship->mass += prod * MASS_FUEL;
		}
	}
       } else {
	/* we have no assignment -- we must launch. taken care of
	   in doship */
       }

      } else {	/* orbiting a planet */

	if (ship->object.number2) {

	 if (ship->whatdest==LEVEL_PLAN && ship->deststar==ship->storbits && 
		ship->destpnum==ship->pnumorbits) {
			/* we just arrived from somewhere */
	    if (planet->type==TYPE_GASGIANT) {
	      if (ship->fuel >= Shipdata[OTYPE_VN][ABIL_FUELCAP])
		ship->object.number2 = 0;
			/* gas giants are of no use to us;
			   doship() will head us somewhere else */
	    } else {
		/* find a place on the planet to land */
		int x,y; reg int d;		/* auto vars for & */
		printf(" VN finding a place to land\n");
		Getxysect(planet,&x,&y,1);
		while ((d=Getxysect(planet,&x,&y,0)) && 
				Sector(*planet,x,y).resource == 0)
				 ;

		if (d) {
			printf(" VN landed.\n");
			ship->is_docked = 1;
			ship->whatdest = LEVEL_PLAN;
			ship->deststar = ship->storbits;
			ship->destpnum = ship->pnumorbits;

			ship->xpos = x;
			ship->ypos = y;
			ship->object.number2 = 1;
			/* number2 means we are currently
			   busy here */
		} else {
			 /* head somewhere else */
			ship->object.number2 = 0;
			printf("turning off; can't find place 2land\n");
		}
	    }
	 } else {
		/* we just launched from this planet -- pick
		   someplace to go to (taken care of in doship) */
	 }
	} else {
		/* okay, we don't know what the hell we are doing here. 
		   wait for doship to give further orders. */
	}
      }

     }

}
