/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *  disk input/output routines
 *
 *  Fileread(p, num, file, posn, routine); -- generic file read
 *  Filewrite(p, num, file, posn, routine); -- generic file write
 *
 */

#include "GB_copyright.h"
#include "tweakables.h"
#include "files.h"
#include <sys/file.h>
#include <signal.h>
#include <errno.h>
int sys_nerr;
char buf[1024];
extern char *sys_errlist[];
extern int errno;

close_file(fd)
int fd;
{
	close(fd);
	return;
}



Fileread(fd, p, num, file, posn)
int fd;
char *p;
int num;
char *file;
int posn;
{
 int n2, abort = 0;

/* printf(" fread fd=%d,reading %d bytes %s posn %d \n",fd,num,file,posn); */

 if (lseek(fd, posn, L_SET) < 0) {
	perror("file read");
	return;
 }

 if ((n2=read(fd,p,num))!=num) {
	perror("fileread");
	printf("fileread: bad # of bytes read from %s (%d != %d).\n",file,n2,num);
 }

}



Filewrite(fd, p, num, file, posn)
int fd;
char *p;
int num;
char *file;
int posn;
{
int mask;
int n2;
int Num_races, i;

Num_races=Numraces();

   mask = sigblock(SIGBLOCKS);

/* printf(" fd =%d writing %d bytes to %s posn %d.\n",fd,num,file,posn); */

 if (lseek(fd, posn, L_SET) < 0) {
	char buf[100];
	sprintf(buf,"%s: err %d",file,errno);
	perror(buf);
	return;
 }

 if ((n2=write(fd,p,num))!=num) {
	char buf[100];
	sprintf(buf,"%s:bad # of bytes written. (%d!=%d)\n",file,n2,num);
	perror(buf);
	return;
 }

   sigsetmask(mask);
}



