/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 *  Getplace -- returns directory level from string and current Dir
 *  Dispplace -- returns string from directory level
 *  testship(ship) -- tests various things for the ship.
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "races.h"
#include "ships.h"
#include "buffers.h"
#include <ctype.h>
int getplace_racedata;

char Disps[PLACENAMESIZE];

placetype Getplace2();

placetype Getplace(Playernum,string, ignoreexpl)
int Playernum;
char *string;
int ignoreexpl;
{
 boolean error;
 int getplace_shdata;
 placetype where;	/* return value */

 Bzero(where);

free(Race);
openracedata(&getplace_racedata);
getrace(getplace_racedata, &Race, Playernum);
close_file(getplace_racedata);

where.err = 0;

 switch (*string) {
	  case '/':
		   where.level=LEVEL_UNIV;	/* scope = root (universe) */
		   where.snum=0;
		   where.pnum= where.shipno=0;
		   return(Getplace2(Playernum, string+1,&where,ignoreexpl,Race->God));
	 case '#':
		   sscanf(++string,"%hd",&where.shipno);
		   openshdata(&getplace_shdata);
		   if (!getship(getplace_shdata,&where.shipptr,where.shipno)) {
			close_file(getplace_shdata);
			DontOwnErr(Playernum,where.shipno);
			where.err = 1;
			return where;
		   }
		   close_file(getplace_shdata);
		   if ( (where.shipptr->owner==Playernum || ignoreexpl || Race->God)
				&& (where.shipptr->is_alive || Race->God)) {
/*			   if (!where.shipptr->is_alive)
				printf("Ship is dead.\n"); */
			   where.level = LEVEL_SHIP;
			   where.snum = where.shipptr->storbits;
			   where.pnum = where.shipptr->pnumorbits;
			/* where.shipno already taken care of */
			   while (isdigit(*string)) 
				string++;
			   if (*string=='/')
				 return Getplace2(Playernum, string+1,&where, ignoreexpl,Race->God);
			   else
				 return where;
		   } else {
			where.err = 1;
			if (where.shipptr->is_alive)
				DontOwnErr(Playernum,where.shipno);

			return where;
		   }

	 case '-':
			/* no destination */
		   where.level = LEVEL_UNIV;
		   return where;

	default:
			/* copy current scope to scope */
		   where.level = Dir[Playernum-1].level;
		   where.snum = Dir[Playernum-1].snum;
		   where.pnum = Dir[Playernum-1].pnum;
		   if (where.level==LEVEL_SHIP) {
			   where.shipno = Dir[Playernum-1].shipno;
			   openshdata(&getplace_shdata);
			   getship(getplace_shdata,&(where.shipptr),where.shipno);
			   close_file(getplace_shdata);
		   }
		   if (*string==CHAR_CURR_SCOPE)
			return where;
		   else 
			return Getplace2(Playernum, string,&where, ignoreexpl,Race->God);
 }

}



placetype Getplace2(Playernum, string,where, ignoreexpl,God)
int Playernum;
char *string;
placetype *where;
int ignoreexpl;
int God;
{
char substr[NAMESIZE];
planettype *p;
shiptype *s;
register int i,l;
int shdata,tick;
int getplace2_pdata;

/* printf("getplace2:looking for '%s'\n",string); */

 if (where->err || *string=='\0' || *string=='\n')
	return(*where);		/* base cases */

 else if (*string=='.') {
    if (where->level==LEVEL_UNIV) {
	sprintf(buf,"Can't go higher.\n");
		notify(Playernum, buf);
	where->err=1;
	return(*where);
    } else {
	if (where->level==LEVEL_SHIP)
		where->level = where->shipptr->whatorbits;
	else 
		where->level--;
	while (*string=='.') string++;
	while (*string=='/') string++;
	return(Getplace2(Playernum, string,where,ignoreexpl,God));
    }
 } else {
		/* is a char string, name of something */
    /*printf("before scanf str=`%s`\n",string);*/
    sscanf(string,"%[^/ \n]",substr);
    /*printf("after scanf sub=`%s`\n",substr);*/

    do {
       /*if (isupper(*string) )
		(*string) = tolower(*string);*/
       string++;
    } while (*string!='/' && *string!='\n' && *string!='\0');

    l=strlen(substr);
    if (where->level==LEVEL_UNIV) {
	for (i=0; i<Sdata.numstars; i++)
	   if (!strncmp(substr,Stars[i]->name,l)) {
		 where->level=LEVEL_STAR;
		 where->snum = i;
		 if (ignoreexpl || isset(Stars[where->snum]->explored, Playernum) || God) {
			 tick = (*string=='/');
			 return(Getplace2(Playernum, string+tick, where, ignoreexpl, God));
		 }
		 sprintf(buf,"You have not explored %s yet.\n",
						Stars[where->snum]->name);
			notify(Playernum, buf);
		 where->err = 1;
		 return(*where);
	   }
	if (i>=Sdata.numstars) {
		sprintf(buf,"No such star %s.\n",substr);
			notify(Playernum, buf);
		where->err=1;
		return(*where);
	}
    } else if (where->level==LEVEL_STAR) {
	for (i=0; i<Stars[where->snum]->numplanets; i++)
	   if (!strncmp(substr,Stars[where->snum]->pnames[i],l)) {
		 where->level=LEVEL_PLAN;
		 where->pnum = i;
		 openpdata(&getplace2_pdata);
		 getplanet(getplace2_pdata, &p, Stars[where->snum]->planetpos[i]);
		 close_file(getplace2_pdata);
		 if (ignoreexpl || p->info[Playernum-1].explored || God) {
			 free(p);
			 tick = (*string=='/');
			 return(Getplace2(Playernum, string+tick,where,ignoreexpl, God));
		 }
		 sprintf(buf,"You have not explored %s yet.\n",Stars[where->snum]->pnames[i]);
			notify(Playernum, buf);
		 where->err = 1;
		 free(p);
		 return(*where);
	   }
	if (i >= Stars[where->snum]->numplanets) {
		sprintf(buf,"No such planet %s.\n",substr);
			notify(Playernum, buf);
		where->err=1;
		return(*where);
	}
    } else if (where->level==LEVEL_PLAN) {
	sprintf(buf,"Can't descend to %s.\n",substr);
			notify(Playernum, buf);
	where->err=1;
	return(*where);
    }
 }
}



char *Dispplace(Playernum, where)
placetype *where;
{

 switch (where->level) {
      case LEVEL_STAR:
	     sprintf(Disps,"/%s",Stars[where->snum]->name);
	     return(Disps);
      case LEVEL_PLAN:
	     sprintf(Disps,"/%s/%s",Stars[where->snum]->name, Stars[where->snum]->pnames[where->pnum]);
	     return(Disps);
      case LEVEL_SHIP:
	     sprintf(Disps,"#%d",where->shipno);
	     return(Disps);
      case LEVEL_UNIV:
	     return("-");
      default:
	     sprintf(buf,"illegal Dispplace val = %d\n",where->level);
			notify(Playernum, buf);
	     where->err = 1;
	     return("/");
	     break;
 }
}



int testship(Playernum,s,n)
int Playernum;
reg shiptype *s;
reg int n;
{
reg int r;

r=0;

 if (!s->is_alive) {
	sprintf(buf,"%s #%d has been destroyed.\n", Shipnames[s->type], n);
			notify(Playernum, buf);
	r = 1;
 } else if (s->owner != Playernum) {
	DontOwnErr(Playernum,n);
	r = 1;
 } else {
   if (!s->active) {
	sprintf(buf,"%s #%d is irradiated %d %% and inactive.\n",Shipnames[s->type], n,s->rad);
			notify(Playernum, buf);
	r = 1;
   } 
   if (!s->popn && Max_crew(s)) {
	sprintf(buf,"%s #%d %s has no crew and is not a robotic ship.\n", 
		Shipnames[s->type], n, s->name );
			notify(Playernum, buf);
	r = 1;
   }
 }
 return r;
}
