/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 * tech.c -- increase investment in technological development.
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "races.h"
#include "buffers.h"
#include <math.h>
#include <signal.h>
#include <ctype.h>
int tech_pdata;

technology(Playernum,APcount, argn, args)
int Playernum;
int APcount, argn;
char args[MAXARGS][COMMANDSIZE];
{
int c,invest;
planettype *p;

tech_pdata = NEUTRAL_FD;

if (Dir[Playernum-1].level != LEVEL_PLAN) {
	sprintf(buf,"scope must be a planet (%d).\n", Dir[Playernum-1].level);
		notify(Playernum, buf);
	return;
}
if (!enufAP(Playernum,Stars[Dir[Playernum-1].snum]->AP[Playernum-1], APcount)) {
	return;
	}

 openpdata(&tech_pdata);
 getplanet(tech_pdata,&p,Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
close_file(tech_pdata);

if(argn < 2) {
	sprintf(buf, "Current investment : %d    Technology production/update: %.2f\n",
		p->info[Playernum-1].tech_invest,
		log10(1.0+(double)p->info[Playernum-1].tech_invest)*TECH_INVEST);
	notify(Playernum, buf);
	return;
		}

 	invest=atoi(args[1]);

	if (invest > 100 || invest < 0) {
		sprintf(buf,"Illegal value.\n");
			notify(Playernum, buf);
		return;
	}
	p->info[Playernum-1].tech_invest = invest;
openpdata(&tech_pdata);
putplanet(tech_pdata,p,Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
 close_file(tech_pdata);

	deductAPs(Playernum,APcount, Dir[Playernum-1].snum, 0);

	sprintf(buf,"   New (ideal) tech production: %.2f (this planet)\n", 
		log10(1.0+(double)p->info[Playernum-1].tech_invest) * TECH_INVEST );
	notify(Playernum, buf);


 free(p);

}

